VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   2388
   ClientLeft      =   108
   ClientTop       =   432
   ClientWidth     =   3552
   LinkTopic       =   "Form1"
   ScaleHeight     =   2388
   ScaleWidth      =   3552
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   732
      Left            =   240
      TabIndex        =   0
      Top             =   1320
      Width           =   2412
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim oHttpRequest

'  WinHttpRequest
Const WinHttpRequestOption_UserAgentString = 0
Const WinHttpRequestOption_URL = 1
Const WinHttpRequestOption_URLCodePage = 2

Sub LoginAvito(login, password)
    Dim oHtmlDoc
    Dim oHtmlForm
    '    URL
    Set oHtmlDoc = documentFromURL(oHttpRequest, "https://m.avito.ru/profile/login")
    ' 
    Set oHtmlForm = oHtmlDoc.Forms(0)
    '    
    oHtmlForm("login").value = login
    oHtmlForm("password").value = password
    '  
    SubmitForm oHttpRequest, oHtmlForm
    '  200   ,      
    If oHttpRequest.Status <> 200 Then
      Err.Raise vbObjectError + 1, "LoginAvito", "  .   : " & oHttpRequest.Status & " " & oHttpRequest.StatusText
        'MsgBox "    ", vbCritical
      Exit Sub
    End If

    '      .      " "   .
    If InStr(1, oHttpRequest.responseText, " ", vbTextCompare) > 0 Then
        Err.Raise vbObjectError + 2, "LoginAvito", "   ."
        Exit Sub
    End If

    MsgBox parseHTML(oHttpRequest.responseText).Body.outerText
End Sub

'  
Sub UploadImage()
    Dim sCurrentFolderPath
    Dim oRequestDataBuilder

    '   
    sCurrentFolderPath = GetParentFolderPath(WScript.ScriptFullName)

    Set oRequestDataBuilder = New cRequestDataBuilder
    With oRequestDataBuilder
      .Url = "https://m.avito.ru/add/image"
      .AddFile "image[]", sCurrentFolderPath & "image.png", "image/png"
      .Method = "POST"
      .ContentType = "multipart/form-data"
        .Build
    End With
    
    ' 
    SubmitRequestData oHttpRequest, oRequestDataBuilder
    
    '    
    WScript.Echo oHttpRequest.responseText
End Sub

'   
Function GetParentFolderPath(sPath)
   Dim p1, p2
    p1 = InStrRev(sPath, "\")
   p2 = InStrRev(sPath, "/")
   If p2 > p1 Then p1 = p2
   GetParentFolderPath = Left(sPath, p1)
End Function

'  HTML    URL
Function documentFromURL(HttpRequest, Url)
    With HttpRequest
        .Open "GET", Url, False
        .Send
        Set documentFromURL = parseHTML(.responseText)
    End With
End Function

'  HTML .  HTML Document
Function parseHTML(data)
    Dim oHtmlDoc
    Set oHtmlDoc = CreateObject("htmlfile")
    With oHtmlDoc
        '  
        .designMode = "on"
        .Write data
        .Close
        '  ActiveX 
        .execCommand ("stop")
    End With
    Set parseHTML = oHtmlDoc
End Function

'   
'(!)   <input type=file>    value
'       "filePath"
Sub SubmitForm(HttpRequest, HtmlForm)
   Dim oRequestDataBuilder
    Dim oElement
    Dim FilePath
   Set oRequestDataBuilder = New cRequestDataBuilder
    With oRequestDataBuilder
      .Url = BuildURL(HttpRequest.Option(1), HtmlForm.Action)
       .Method = HtmlForm.Method
       .ContentType = HtmlForm.GetAttribute("enctype")
       For Each oElement In HtmlForm.Elements
            If oElement.Name <> "" Then
                If LCase(oElement.Type) = "file" Then
                    .AddFile oElement.Name, oElement.GetAttribute("filePath"), oElement.GetAttribute("contentType")
                Else
               .AddField oElement.Name, oElement.value
                End If
            End If
        Next
        SubmitRequestData HttpRequest, oRequestDataBuilder
   End With
End Sub

'    RequestDataBuilder
'(!)    ,   ,    
Sub SubmitRequestData(HttpRequest, RequestDataBuilder)
    With RequestDataBuilder
       .Build
       HttpRequest.Open .Method, .Url, False
       
        ' Referer.      
       On Error Resume Next
       HttpRequest.SetRequestHeader "Referer", HttpRequest.Option(1)
       On Error GoTo 0
       
       Select Case UCase(.Method)
       Case "GET"
         HttpRequest.Send
        Case "POST"
         HttpRequest.SetRequestHeader "Content-Type", .ContentType
         HttpRequest.Send .Body
       End Select
    End With
End Sub

'  URL  
'(!)      Action     : "/data/post.php"
Function BuildURL(Href, Url)
    Dim oHtmlDoc, oBaseTag, oATag
    Set oHtmlDoc = CreateObject("htmlfile")
    oHtmlDoc.Open
    With oHtmlDoc.createElement("base")
        .Href = Href
        oHtmlDoc.Write .outerHTML
    End With
    With oHtmlDoc.createElement("a")
        .Href = Url
        oHtmlDoc.Write .outerHTML
    End With
    oHtmlDoc.Close
    BuildURL = oHtmlDoc.All.tags("a")(0).Href
End Function

Private Sub Command1_Click()
    LoginAvito "theqdd2@gmail.com", "123123"
End Sub

Private Sub Form_Load()
    Set oHttpRequest = CreateObject("WinHttp.WinHttpRequest.5.1")
    oHttpRequest.Option(WinHttpRequestOption_UserAgentString) = "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/41.0.2272.101 Safari/537.36"
End Sub
